#include <linux/in.h>
#include <linux/net.h>
#include <linux/types.h>
#include <linux/time.h>
#include <asm/errno.h>
#include <asm/fcntl.h>
#include <asm/unistd.h>

static int errno;

static __inline__ _syscall1(int,close,int,a1)
static __inline__ _syscall2(int,dup2,int,a1,int,a2)
static __inline__ _syscall1(int,exit,int,a1)
static __inline__ _syscall3(long,fcntl,int,a1,int,a2,unsigned long,a3)
static __inline__ _syscall0(int,fork)
static __inline__ _syscall5(int,_newselect,int,a1,fd_set *,a2,fd_set *,a3,fd_set *,a4,struct timeval *,a5)
static __inline__ _syscall2(int,nanosleep,struct timespec *,a1,struct timespec *,a2)
static __inline__ _syscall4(int,wait4,int,a1,int *,a2,int,a3,void *,a4)
static __inline__ _syscall3(int,write,int,a1,const char *,a2,off_t,a3)
static __inline__ _syscall2(int,socketcall,int,a1,unsigned long *,args)

static unsigned char buf[5];
#define __hns(X) ((((X)&0xff)<<8)|((X)>>8))
#define hhex(X,Y) ((Y=((X)>>4))>9?Y+'a'-10:Y+'0')
#define lhex(X,Y) ((Y=((X)&15))>9?Y+'a'-10:Y+'0')

/* splitting these off as functions makes the executable smaller since
 * gcc is smarter about optimizing them, even though they are only called
 * once (using gcc 2.7.2.3)
 */
static __inline__ void note_net(unsigned int i) {
  int j;

  buf[0] = hhex(i, j);
  buf[1] = lhex(i, j);
}

static __inline__ void quick_write(unsigned int i) {
  int j;

  buf[2] = hhex(i, j);
  buf[3] = lhex(i, j);
  write(0, (char *)buf, 5);
}

extern void _start() {
  static unsigned long sargs[3] = { PF_INET, SOCK_STREAM, IPPROTO_TCP };
  static unsigned long cargs[3];
  static unsigned long gargs[3];
  static union {
    struct timespec ts;
    struct timeval tv;
  } tm;
  static unsigned int i;
  static int p, l;
  static struct sockaddr_in saddr;
  static fd_set fds, rf, wf;

  buf[4] = '\n';
  gargs[1] = cargs[1] = (unsigned long)&saddr;
  gargs[2] = (unsigned long)&l;
  cargs[2] = sizeof(struct sockaddr_in);
  FD_ZERO(&fds);
  for(i=1;i<=254;i++)
    FD_SET(i, &fds);
  for(i=0;i<=255;i++)
    if(i != 1)
      close(i);
  dup2(1, 0);
  close(1);
  saddr.sin_family = AF_INET;
  saddr.sin_port = __hns(DSTPORT);
  for(i=0; i<=255; i++) {
    saddr.sin_addr.s_addr = __hns(CLASSB) | (i<<16);
    if((p = fork())) {
      if(p == -1)
        goto ERR_EXIT;
      else {
        while(wait4(-1, &p, WNOHANG, NULL) > 0);
        tm.ts.tv_sec = 1;
        tm.ts.tv_nsec = 0;
        while (nanosleep(&tm.ts,&tm.ts) == -1 && errno == EINTR);
      }
    } else {
      break;
    }
  }
  if(i == 256) {
    while(wait4(-1, &p, 0, NULL) != -1 && errno != EINTR);
    if(errno == ECHILD)
      goto EXIT;
  } else {
    tm.tv.tv_sec = 30;
    tm.tv.tv_usec = 0;
    note_net(i);
    for(i=1; i<=254; i++) {
      cargs[0] = i;
      saddr.sin_addr.s_addr |= i<<24;
      if(socketcall(SYS_SOCKET, &sargs[0]) != i ||
         fcntl(i, F_SETFL, O_RDWR|O_NONBLOCK) == -1 ||
         socketcall(SYS_CONNECT, &cargs[0]) != -1 ||
         errno != EINPROGRESS)
        goto ERR_EXIT;
      saddr.sin_addr.s_addr &= ~0xff000000L;
    }
    rf = wf = fds;
    while((p=_newselect(255, &rf, &wf, NULL, &tm.tv)) > 0) {
      for(i=1; p && i <= 254; i++)
        if(FD_ISSET(i, &rf) || FD_ISSET(i, &wf)) {
          p--;
          l = sizeof(saddr);
          FD_CLR(i, &fds);
          gargs[0] = i;
          if(socketcall(SYS_GETPEERNAME, &gargs[0]) == 0)
            quick_write(i);
          close(i);
        }
      rf = wf = fds;
    }
    if(p == 0)
      goto EXIT;
  }
ERR_EXIT:
  write(0, "XXXX\n", 5);
EXIT:
  exit(0);
}
